require_dependency 'resource_planner/application_controller'

module ResourcePlanner
  class EventUnitSubscriptionsController < ApplicationController
    before_action :set_event_unit_subscription, only: [:show, :edit, :update, :destroy]

    # GET /event_unit_subscriptions
    def index
      @event_unit_subscriptions = if params[:event_unit_id].nil?
                                    ResourcePlanner::EventUnitSubscription.all
                                  else
                                    event_unit = ResourcePlanner::EventUnit.find(params[:event_unit_id])
                                    event_unit.present? ? event_unit.event_unit_subscriptions : nil
                                  end

      respond_to do |format|
        format.html # index.html.erb
        format.xml  { render xml: @event_unit_subscriptions }
        format.json # index.json.jbuilder
        # format.json { render ('index.json.jbuilder') }
        # format.json { render json: @event_unit_subscriptions }
      end
    end

    # GET /event_unit_subscriptions/1
    def show
      respond_to do |format|
        # format.html # show.html.erb
        format.xml  { render xml: @event_unit_subscription }
        format.json { render json: @event_unit_subscription }
      end
    end

    # GET /event_unit_subscriptions/new
    def new
      @event_unit_subscription = ResourcePlanner::EventUnitSubscription.new
    end

    # GET /event_unit_subscriptions/1/edit
    def edit
    end

    # POST /event_unit_subscriptions
    def create
      @event_unit_subscription = ResourcePlanner::EventUnitSubscription.new(event_unit_params)

      respond_to do |format|
        if @event_unit_subscription.save
          # format.html { redirect_to @event_unit_subscription, notice: 'EventUnitSubscription was successfully created.' }
          format.xml  { render xml: @event_unit_subscription, status: :created, location: @event_unit_subscription }
          format.json { render json: @event_unit_subscription, status: :created, location: @event_unit_subscription }
        else
          # format.html { render :new }
          format.xml  { render xml: @event_unit_subscription.errors, status: :unprocessable_entity }
          format.json { render json: @event_unit_subscription.errors, status: :unprocessable_entity }
        end
      end
    end

    # PATCH/PUT /event_unit_subscriptions/1
    def update
      if @event_unit_subscription.update(event_unit_params)
        # format.html { redirect_to @event_unit_subscription, notice: 'EventUnitSubscription was successfully updated.' }
        format.xml  { head :ok }
        format.json { head :no_content }
      else
        # format.html { render :edit }
        format.xml  { render xml: @event_unit_subscription.errors, status: :unprocessable_entity }
        format.json { render json: @event_unit_subscription.errors, status: :unprocessable_entity }
      end
    end

    # DELETE /event_unit_subscriptions/1
    def destroy
      @event_unit_subscription.destroy

      respond_to do |format|
        # format.html { redirect_to event_units_url, notice: 'EventUnitSubscription was successfully destroyed.' }
        format.xml  { head :ok }
        format.json { head :no_content }
      end
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_event_unit_subscription
      @event_unit_subscription = ResourcePlanner::EventUnitSubscription.find(params[:id])
    end

    # Only allow a trusted parameter "white list" through.
    def event_unit_params
      params.fetch(:event_unit_subscription, {})
    end
  end
end
